// DlgOptions.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "FemFind.h"
#include "DlgOptions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CDlgOptions 


CDlgOptions::CDlgOptions(CHistory * history, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgOptions::IDD, pParent), m_hist(history)
{
	//{{AFX_DATA_INIT(CDlgOptions)
	m_history_limit = 0;
	m_history = FALSE;
	m_server_new = _T("");
	m_ping = FALSE;
	//}}AFX_DATA_INIT

	ReadConfig();
}


void CDlgOptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOptions)
	DDX_Control(pDX, IDC_HISTORY_LIMIT, m_ctlHistory);
	DDX_Control(pDX, IDC_REMOTE_CONFIG, m_cbCfgServer);
	DDX_Text(pDX, IDC_HISTORY_LIMIT, m_history_limit);
	DDX_Check(pDX, IDC_HISTORY, m_history);
	DDX_Text(pDX, IDC_SERVER_NEW, m_server_new);
	DDX_Check(pDX, IDC_PING_HOSTS, m_ping);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgOptions, CDialog)
	//{{AFX_MSG_MAP(CDlgOptions)
	ON_BN_CLICKED(IDC_DELETE_HISTORY, OnDeleteHistory)
	ON_BN_CLICKED(IDC_HISTORY, OnHistory)
	ON_EN_CHANGE(IDC_SERVER_NEW, OnChangeServerNew)
	ON_BN_CLICKED(IDC_SERVER_REMOVE, OnServerRemove)
	ON_BN_CLICKED(IDC_SERVER_ADD, OnServerAdd)
	ON_CBN_SELCHANGE(IDC_REMOTE_CONFIG, OnSelchangeRemoteConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CDlgOptions 

void CDlgOptions::OnDeleteHistory() 
{
	// TODO: Code fr die Behandlungsroutine der Steuerelement-Benachrichtigung hier einfgen
	m_hist->DeleteHistory();
}

BOOL CDlgOptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	ReadConfig();

	m_cbCfgServer.ResetContent();
	for (int i = 0; i < m_cfgserver.GetSize(); i++)
		m_cbCfgServer.AddString(m_cfgserver[i]);
	m_cbCfgServer.SetCurSel(0);

	m_ctlHistory.EnableWindow(m_history);
	UpdateData(FALSE);
	m_server_changed = FALSE;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

void CDlgOptions::OnOK() 
{
	UpdateData(TRUE);

	CStdioFile file;
	CString configfile, line;
	int sel;

	configfile.LoadString(IDS_CONFIGFILE);

	if ((sel = m_cbCfgServer.GetCurSel()) == CB_ERR)
	{
		AfxMessageBox("Kein Rechner ausgewhlt!");
		return;
	}

	m_cbCfgServer.GetLBText(sel, line);
	for (int i = 0; i < m_cfgserver.GetSize(); i++)
		if (m_cfgserver[i] == line)
		{
			ASSERT(i >=0 && i <= m_cfgserver.GetSize());
			m_cfgserver.RemoveAt(i);
		}

	if (file.Open(configfile, CFile::modeCreate | CFile::modeWrite))
	{
		file.WriteString(line + '\n');

		for (i = 0; i < m_cfgserver.GetSize(); i++)
			file.WriteString(m_cfgserver[i] + '\n');

		file.WriteString("---\n");
		line.Format("%u\n", m_history_limit + 1);
		file.WriteString(line);
		line = m_history ? "ON\n" : "OFF\n";
		file.WriteString(line);
		line = m_ping ? "ON\n" : "OFF\n";
		file.WriteString(line);

		file.Close();
	}

	CDialog::OnOK();
}

void CDlgOptions::OnHistory() 
{
	UpdateData(TRUE);
	m_ctlHistory.EnableWindow(m_history);	
}

void CDlgOptions::OnChangeServerNew() 
{
	UpdateData(TRUE);
	((CWnd *)GetDlgItem(IDC_SERVER_ADD))->EnableWindow(!m_server_new.IsEmpty());
}

void CDlgOptions::OnServerRemove() 
{
	CString selection;
	int index;

	if ((index = m_cbCfgServer.GetCurSel()) != CB_ERR)
	{
		m_cbCfgServer.GetLBText(index, selection);
		m_cbCfgServer.DeleteString(index);
		for (int i = 0; i < m_cfgserver.GetSize(); i++)
			if (m_cfgserver[i] == selection)
				m_cfgserver.RemoveAt(i);
	}
	m_cbCfgServer.SetCurSel(0);

	GetDlgItem(IDC_SERVER_REMOVE)->EnableWindow(m_cbCfgServer.GetCount() == 0 ? FALSE : TRUE);

	m_server_changed = TRUE;
}

BOOL CDlgOptions::GetDatabaseParams(CString cfgfile, DATABASE &m_database)
{
	CStdioFile file;

	if (file.Open(cfgfile, CFile::modeRead))
	{
		bool result = (file.ReadString(m_database.host) &&
					   file.ReadString(m_database.login) &&
					   file.ReadString(m_database.password) && 
					   file.ReadString(m_database.dbname));
		file.Close();

		return result ? TRUE : FALSE;
	}
	else
		return FALSE;
}

BOOL CDlgOptions::GetDatabaseConfig(DATABASE &m_database)
{
	CStatic *server_status;
	CDialog server_check;
	CStdioFile file;
	CString line, configfile;
	bool working = false;

	configfile.LoadString(IDS_CONFIGFILE);
	server_check.Create(IDD_SERVER_CHECK);
	server_check.ShowWindow(SW_SHOW);
	server_status = (CStatic *)server_check.GetDlgItem(IDC_SERVER_STATUS);

	if (file.Open(configfile, CFile::modeRead))
	{
		//server_status->SetWindowText("Lese Konfiguration");
		while (!working && file.ReadString(line) && (line.Left(1) != "-"))
		{
			server_status->SetWindowText("Lese Konfiguration von " + line);
			if (!CDlgOptions::GetDatabaseParams(line, m_database))
				continue;

			server_status->SetWindowText("Teste mySQL-Server auf " + m_database.host + ", bitte warten!");
			CMySql mysql(m_database.host, m_database.login,
						 m_database.password, m_database.dbname);
			mysql.LastError(line);
			
			if (line.IsEmpty())
			{
				server_status->SetWindowText("Konfiguration ok");
				working = true;
			}
			else
				AfxMessageBox(line);
		}

		server_check.ShowWindow(SW_HIDE);
		return working ? TRUE : FALSE;
	}
	else
	{
		server_check.ShowWindow(SW_HIDE);
		return FALSE;
	}
}

void CDlgOptions::OnServerAdd() 
{
	UpdateData(TRUE);
	m_cfgserver.Add(m_server_new);
	m_cbCfgServer.SetCurSel(m_cbCfgServer.AddString(m_server_new));

	m_server_changed = TRUE;
}

void CDlgOptions::ReadConfig()
{
	CStdioFile file;
	CString line, configfile;

	configfile.LoadString(IDS_CONFIGFILE);
	m_cfgserver.RemoveAll();

	if (file.Open(configfile, CFile::modeRead))
	{
		while (file.ReadString(line) && line != "---")
		{
			m_cfgserver.Add(line);
		}

		if (file.ReadString(line))
			m_history_limit = atoi(line) == 0 ? 1000 : atoi(line) - 1;
		else
			m_history_limit = 1000;

		if (file.ReadString(line))
			m_history = line == "ON";
		else
			m_history = TRUE;

		if (file.ReadString(line))
			m_ping = line == "ON";
		else
			m_ping = TRUE;

		file.Close();
	}
}

void CDlgOptions::OnSelchangeRemoteConfig() 
{
	m_server_changed = TRUE;
}
